package com.acme;

import org.glassfish.grizzly.CompletionHandler;
import org.glassfish.grizzly.http.server.Response;


public class MyCompletionHandler
    implements CompletionHandler<Response>
{
    private static final byte[]  ERROR509 = "<html><body><h1>ERROR 509</h1></body></html>".getBytes();
    
    @Override
    public void cancelled()
    {
        System.err.println( "Completion -> cancelled" );
    }

    @Override
    public void failed( Throwable th )
    {
        System.err.println( "Completion -> cancelled\n"+th );
    }

    @Override
    public void completed( Response res )
    {
        complete( res );
    }

    @Override
    public void updated( Response res )
    {
        System.out.println( "Completion -> updated" );
    }

    private void complete( Response res )
    {
        try
        {
            // Default response in case of error
            if( res.getStatus() == 509 )
            {
                res.setContentLength( ERROR509.length );
                res.setContentType( "text/html" );
                res.setHeader( "Connection", "close" );
                res.getOutputStream().write( ERROR509 );
            }

            // Flush the response
            flushing( res );
        }
        catch( Exception ex )
        {
            System.err.println( "Error while completing the request" );
            ex.printStackTrace( System.err );
        }
    }

    private void flushing( Response res )
        throws Exception
    {
        res.flush();
    }


    
}
