package com.acme;

import com.acme.upload.Upload;
import com.acme.upload.UploadManager;
import java.io.OutputStream;
import org.glassfish.grizzly.http.server.HttpHandler;
import org.glassfish.grizzly.http.server.Request;
import org.glassfish.grizzly.http.server.Response;

public class MyComplexHandler extends HttpHandler
{
    private static final int MAX_BUFFER_SIZE = 8 * 1024;

    private byte[]          buffer;
    private OutputStream    os;
    private boolean         rejected;
    
    public MyComplexHandler( boolean rejected )
    {
        this.buffer = new byte[MAX_BUFFER_SIZE];
        this.os = new NullOutputStream();
        this.rejected = rejected;
    }

    @Override
    public void service( Request req, Response res ) throws Exception
    {
        if( rejected )
        {
            res.setStatus( 509, "[Grizzly] Sorry but I don't want to process it ! It's my choice !" );
            res.setHeader( "Connection", "close" );
        }
        else
        {
            // Simulate some more time consuming operation
            //Thread.sleep( 1500 );
            UploadManager.getInstance().addUpload( new Upload(req,res) );
        }
    }
    
}
