package com.acme;

import org.glassfish.grizzly.http.server.HttpHandler;
import org.glassfish.grizzly.http.server.Request;
import org.glassfish.grizzly.http.server.Response;


public class MyExecutor implements Runnable
{
    private Request         req;
    private Response        res;
    private HttpHandler     handler;

    public MyExecutor( Request req, Response res, HttpHandler handler )
    {
        this.req = req;
        this.res = res;
        this.handler = handler;
    }

    @Override
    public void run()
    {
        try
        {
            handler.service( req, res );
        }
        catch( Exception ex )
        {
            ex.printStackTrace( System.err );
            res.setStatus( 500, "Error while performing service() in adapter" );
            resume();
        }
        finally
        {
            // Do not resume, it will be done by the upload pool
            //resume();
        }
    }

    private void resume()
    {
        try
        {
            res.resume();
        }
        catch( Exception ex )
        {
            System.err.println( "Error while resuming the response" );
            ex.printStackTrace( System.err );
        }
    }
}
