package com.acme;

import java.io.OutputStream;
import org.glassfish.grizzly.http.server.HttpHandler;
import org.glassfish.grizzly.http.server.Request;
import org.glassfish.grizzly.http.server.Response;


public class MySimpleHandler extends HttpHandler
{
    private static final int BUFFER_SIZE = 64 * 1024;

    private OutputStream    os;
    private boolean         rejected;
    

    public MySimpleHandler( boolean rejected )
    {
        this.os = new NullOutputStream();
        this.rejected = rejected;
    }
    
    @Override
    public void service( Request req, Response res ) throws Exception
    {
        int read;

        if( rejected )
        {
            res.setStatus( 509, "[Simple] Sorry but I don't want to process it ! It's my choice !" );
            res.setHeader( "Connection", "close" );
        }
        else
        {
            byte[]  data = new byte[BUFFER_SIZE];

            // Write somewhere the content of the request
            while( -1!= (read=req.getInputStream(false).read( data )))
            {
                os.write( data, 0, read );
            }

            // Simulate some more time consuming operation
            Thread.sleep( 1500 );

            // Respond
            res.setStatus( 200, "[Simple] Ok, understand" );
        }
    }

}
