/*
 * Copyright (c) 2011 by Axway Software
 * All brand or product names are trademarks or registered trademarks
 * of their respective holders.
 * This document and the software described in this document are the property
 * of Axway Software and are protected as Axway Software trade secrets.
 * No part of this work may be reproduced or disseminated in any form or
 * by any means, without the prior written permission of Axway Software.
 */

package com.acme.upload;

import java.util.concurrent.BlockingQueue;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.LinkedBlockingQueue;

/**
 *
 * @author dgay
 */
public class UploadManager
{
    private static final UploadManager    INSTANCE = new UploadManager();
    private static final int NB_THREAD = 5;
    
    private BlockingQueue<Upload>   queue;
    //private Queue<Upload> queue;
    private ExecutorService         pool;
    
    UploadManager()
    {
        this.queue = new LinkedBlockingQueue<Upload>();
        this.pool = Executors.newFixedThreadPool( NB_THREAD );
        for( int i=0; i<NB_THREAD; i++ )
        {
            pool.submit( new UploadExecutor(queue) );
        }
    }

    public static UploadManager getInstance()
    {
        return INSTANCE;
    }
    
    public void addUpload( Upload upload )
    {
        //System.out.println( "Starting : "+upload );
        //queue.add( upload );
        try
        {
            queue.put( upload );
        }
        catch( Exception ex )
        {
            ex.printStackTrace( System.err );
        }
    }

}
