package com.acme.test;

import java.util.concurrent.atomic.AtomicInteger;
import org.apache.commons.httpclient.DefaultHttpMethodRetryHandler;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpConnectionManager;
import org.apache.commons.httpclient.methods.ByteArrayRequestEntity;
import org.apache.commons.httpclient.methods.PutMethod;
import org.apache.commons.httpclient.methods.RequestEntity;
import org.apache.commons.httpclient.params.HttpMethodParams;

/**
 *
 */
public  class       Caller
        implements  Runnable
{
    //private static final File FDATA = new File( "./target/test-classes/SomeData.data" );
    //private static final Random rnd = new Random();
    
    private String          url;
    private int             count;
    private AtomicInteger   succes;
    private AtomicInteger   busy;
    private HttpClient      client;

    public Caller( String url, int count, AtomicInteger succes, AtomicInteger busy, HttpConnectionManager cm )
    {
        this.url = url;
        this.count = count;
        this.succes = succes;
        this.busy = busy;
        this.client = new HttpClient( cm );
        //this.client.getHostConfiguration().setProxy( "localhost", 8888 );
    }

    @Override
    public void run()
    {
        for( int i=0; i<count; i++ )
        {
            send( PIECE_LITTLE );
            send( PIECE_BIG );
            send( PIECE_LITTLE);
        }
    }
    
    //@Override
    private void send( byte[] data )
    {
        int code;
        int i;
        PutMethod method = null;

        //try{ Thread.sleep( rnd.nextInt(300) ); } catch( Exception ex ) {}
       // for( i=0; i<count; i++ )
        //{
            try
            {
                method = new PutMethod( url );
                method.setRequestHeader( "unknownfield", "hhhh" );
                method.setContentChunked( true );
                method.setRequestEntity( createData(data) );
                method.getParams().setParameter( HttpMethodParams.RETRY_HANDLER, new DefaultHttpMethodRetryHandler(0,false) );
                code = client.executeMethod( method );
                if( code == 200 )
                {
                    succes.getAndIncrement();
                }
                else if( code == 509 )
                {
                    busy.getAndIncrement();
                }
                else
                {
                    System.out.println( "Error returning :"+code );
                }
                //Thread.sleep( rnd.nextInt(1000) );
//                if( i != (count-1) )
//                {
//                    //Thread.sleep( 6000 );
//                }
            }
            catch( Exception ex )
            {
                System.out.println( "BAD :"+ex.getMessage() );
            }
            finally
            {
                method.releaseConnection();
                method = null;
            }
        //}
    }

    private RequestEntity createData( byte[] data )
    {
        //return new FileRequestEntity( FDATA, "application/data" );
        return new ByteArrayRequestEntity( data );
    }

    private static final byte[] PIECE_LITTLE = new byte[4*1024];     // 4K
    private static final byte[] PIECE_BIG = new byte[5*1024*1024];  // 5Mo

    static
    {
        int i;
        byte b;

        
        // Init Start
        b = 0;
        for( i=0; i<PIECE_LITTLE.length; i++ )
        {
            PIECE_LITTLE[0] = b;
            b++;
            if( b<200 ) b = 0;
        }

        // Init Big
        b = 0;
        for( i=0; i<PIECE_BIG.length; i++ )
        {
            PIECE_BIG[0] = b;
            b++;
            if( b<200 ) b = 0;
        }

    }
}
